import{s as Ye,c as tt,u as nt,g as ot,d as at,o as it,n as rt}from"../chunks/scheduler.7da89386.js";import{S as Ze,i as et,g as l,h as c,j as w,f as i,k as F,a as $,d as _,t as b,s as r,r as y,A as st,c as s,u as v,x as S,y as t,v as T,w as x}from"../chunks/index.0b7befd3.js";import{D as N}from"../chunks/Docstring.519b22f2.js";import{H as Xe}from"../chunks/Heading.8a936589.js";function lt(h){let n,g;const f=h[3].default,d=tt(f,h,h[2],null);return{c(){n=l("div"),d&&d.c(),this.h()},l(a){n=c(a,"DIV",{class:!0});var u=w(n);d&&d.l(u),u.forEach(i),this.h()},h(){F(n,"class","course-tip "+(h[0]==="orange"?"course-tip-orange":"")+" bg-gradient-to-br dark:bg-gradient-to-r before:border-"+h[0]+"-500 dark:before:border-"+h[0]+"-800 from-"+h[0]+"-50 dark:from-gray-900 to-white dark:to-gray-950 border border-"+h[0]+"-50 text-"+h[0]+"-700 dark:text-gray-400")},m(a,u){$(a,n,u),d&&d.m(n,null),g=!0},p(a,[u]){d&&d.p&&(!g||u&4)&&nt(d,f,a,a[2],g?at(f,a[2],u,null):ot(a[2]),null)},i(a){g||(_(d,a),g=!0)},o(a){b(d,a),g=!1},d(a){a&&i(n),d&&d.d(a)}}}function ct(h,n,g){let{$$slots:f={},$$scope:d}=n,{warning:a=!1}=n;const u=a?"orange":"green";return h.$$set=o=>{"warning"in o&&g(1,a=o.warning),"$$scope"in o&&g(2,d=o.$$scope)},[u,a,d,f]}class dt extends Ze{constructor(n){super(),et(this,n,ct,lt,Ye,{warning:1})}}function mt(h){let n,g=`To use this method, you need to have provided a <code>model_init</code> when initializing your <a href="/docs/setfit/main/en/api/trainer#setfit.SetFitTrainer">SetFitTrainer</a>: we need to
reinitialize the model at each new run.`;return{c(){n=l("p"),n.innerHTML=g},l(f){n=c(f,"P",{"data-svelte-h":!0}),S(n)!=="svelte-ngulr9"&&(n.innerHTML=g)},m(f,d){$(f,n,d)},p:rt,d(f){f&&i(n)}}}function pt(h){let n,g,f,d,a,u,o,O,ve,J,He="Trainer to train a SetFit model.",Te,k,R,xe,Q,Ue="Applies a dictionary of hyperparameters to both the trainer and the model",we,M,H,Fe,X,Ee="Computes the metrics for a given classifier.",Se,L,U,$e,Y,je=`Freeze SetFitModel’s differentiable head.
Note: call this function only when using the differentiable head.`,De,C,E,Ce,Z,Ve=`Launch a hyperparameter search using <code>optuna</code>. The optimized quantity is determined
by <code>compute_objective</code>, which defaults to a function returning the evaluation loss when no metric is provided,
the sum of all metrics otherwise.`,ze,I,Ne,z,j,ke,ee,We="Upload model checkpoint to the Hub using <code>huggingface_hub</code>.",Me,te,Be='See the full list of parameters for your <code>huggingface_hub</code> version in the        <a href="https://huggingface.co/docs/huggingface_hub/package_reference/mixins#huggingface_hub.ModelHubMixin.push_to_hub" rel="nofollow">huggingface_hub documentation</a>.',Le,q,V,Ie,ne,Ke="Main training entry point.",qe,P,W,Pe,oe,Ge=`Unfreeze SetFitModel’s differentiable head.
Note: call this function only when using the differentiable head.`,de,B,me,D,K,Ae,ae,Je="Trainer to compress a SetFit model with knowledge distillation.",Oe,A,G,Re,ie,Qe="Main training entry point.",pe,ce,he;return a=new Xe({props:{title:"SetFitTrainer",local:"setfit.SetFitTrainer",headingTag:"h1"}}),O=new N({props:{name:"class setfit.SetFitTrainer",anchor:"setfit.SetFitTrainer",parameters:[{name:"model",val:": typing.Optional[ForwardRef('SetFitModel')] = None"},{name:"train_dataset",val:": typing.Optional[ForwardRef('Dataset')] = None"},{name:"eval_dataset",val:": typing.Optional[ForwardRef('Dataset')] = None"},{name:"model_init",val:": typing.Union[typing.Callable[[], ForwardRef('SetFitModel')], NoneType] = None"},{name:"metric",val:": typing.Union[str, typing.Callable[[ForwardRef('Dataset'), ForwardRef('Dataset')], typing.Dict[str, float]]] = 'accuracy'"},{name:"metric_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"loss_class",val:" = <class 'sentence_transformers.losses.CosineSimilarityLoss.CosineSimilarityLoss'>"},{name:"num_iterations",val:": int = 20"},{name:"num_epochs",val:": int = 1"},{name:"learning_rate",val:": float = 2e-05"},{name:"batch_size",val:": int = 16"},{name:"seed",val:": int = 42"},{name:"column_mapping",val:": typing.Union[typing.Dict[str, str], NoneType] = None"},{name:"use_amp",val:": bool = False"},{name:"warmup_proportion",val:": float = 0.1"},{name:"distance_metric",val:": typing.Callable = <function BatchHardTripletLossDistanceFunction.cosine_distance at 0x7fd4e7aae160>"},{name:"margin",val:": float = 0.25"},{name:"samples_per_label",val:": int = 2"}],parametersDescription:[{anchor:"setfit.SetFitTrainer.model",description:`<strong>model</strong> (<code>SetFitModel</code>, <em>optional</em>) &#x2014;
The model to train. If not provided, a <code>model_init</code> must be passed.`,name:"model"},{anchor:"setfit.SetFitTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>Dataset</code>) &#x2014;
The training dataset.`,name:"train_dataset"},{anchor:"setfit.SetFitTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>Dataset</code>, <em>optional</em>) &#x2014;
The evaluation dataset.`,name:"eval_dataset"},{anchor:"setfit.SetFitTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], SetFitModel]</code>, <em>optional</em>) &#x2014;
A function that instantiates the model to be used. If provided, each call to <a href="/docs/setfit/main/en/api/trainer#setfit.SetFitTrainer.train">train()</a> will start
from a new instance of the model as given by this function when a <code>trial</code> is passed.`,name:"model_init"},{anchor:"setfit.SetFitTrainer.metric",description:`<strong>metric</strong> (<code>str</code> or <code>Callable</code>, <em>optional</em>, defaults to <code>&quot;accuracy&quot;</code>) &#x2014;
The metric to use for evaluation. If a string is provided, we treat it as the metric name and load it with default settings.
If a callable is provided, it must take two arguments (<code>y_pred</code>, <code>y_test</code>).`,name:"metric"},{anchor:"setfit.SetFitTrainer.metric_kwargs",description:`<strong>metric_kwargs</strong> (<code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
Keyword arguments passed to the evaluation function if <code>metric</code> is an evaluation string like &#x201C;f1&#x201D;.
For example useful for providing an averaging strategy for computing f1 in a multi-label setting.`,name:"metric_kwargs"},{anchor:"setfit.SetFitTrainer.loss_class",description:`<strong>loss_class</strong> (<code>nn.Module</code>, <em>optional</em>, defaults to <code>CosineSimilarityLoss</code>) &#x2014;
The loss function to use for contrastive training.`,name:"loss_class"},{anchor:"setfit.SetFitTrainer.num_iterations",description:`<strong>num_iterations</strong> (<code>int</code>, <em>optional</em>, defaults to <code>20</code>) &#x2014;
The number of iterations to generate sentence pairs for.
This argument is ignored if triplet loss is used.
It is only used in conjunction with <code>CosineSimilarityLoss</code>.`,name:"num_iterations"},{anchor:"setfit.SetFitTrainer.num_epochs",description:`<strong>num_epochs</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
The number of epochs to train the Sentence Transformer body for.`,name:"num_epochs"},{anchor:"setfit.SetFitTrainer.learning_rate",description:`<strong>learning_rate</strong> (<code>float</code>, <em>optional</em>, defaults to <code>2e-5</code>) &#x2014;
The learning rate to use for contrastive training.`,name:"learning_rate"},{anchor:"setfit.SetFitTrainer.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>16</code>) &#x2014;
The batch size to use for contrastive training.`,name:"batch_size"},{anchor:"setfit.SetFitTrainer.seed",description:`<strong>seed</strong> (<code>int</code>, <em>optional</em>, defaults to 42) &#x2014;
Random seed that will be set at the beginning of training. To ensure reproducibility across runs, use the
<code>~SetTrainer.model_init</code> function to instantiate the model if it has some randomly initialized parameters.`,name:"seed"},{anchor:"setfit.SetFitTrainer.column_mapping",description:`<strong>column_mapping</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A mapping from the column names in the dataset to the column names expected by the model. The expected format is a dictionary with the following format: {&#x201C;text_column_name&#x201D;: &#x201C;text&#x201D;, &#x201C;label_column_name: &#x201C;label&#x201D;}.`,name:"column_mapping"},{anchor:"setfit.SetFitTrainer.use_amp",description:`<strong>use_amp</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Use Automatic Mixed Precision (AMP). Only for Pytorch &gt;= 1.6.0`,name:"use_amp"},{anchor:"setfit.SetFitTrainer.warmup_proportion",description:`<strong>warmup_proportion</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.1</code>) &#x2014;
Proportion of the warmup in the total training steps.
Must be greater than or equal to 0.0 and less than or equal to 1.0.`,name:"warmup_proportion"},{anchor:"setfit.SetFitTrainer.distance_metric",description:`<strong>distance_metric</strong> (<code>Callable</code>, defaults to <code>BatchHardTripletLossDistanceFunction.cosine_distance</code>) &#x2014;
Function that returns a distance between two embeddings.
It is set for the triplet loss and
is ignored for <code>CosineSimilarityLoss</code> and <code>SupConLoss</code>.`,name:"distance_metric"},{anchor:"setfit.SetFitTrainer.margin",description:`<strong>margin</strong> (<code>float</code>, defaults to <code>0.25</code>) &#x2014; Margin for the triplet loss.
Negative samples should be at least margin further apart from the anchor than the positive.
This is ignored for <code>CosineSimilarityLoss</code>, <code>BatchHardSoftMarginTripletLoss</code> and <code>SupConLoss</code>.`,name:"margin"},{anchor:"setfit.SetFitTrainer.samples_per_label",description:`<strong>samples_per_label</strong> (<code>int</code>, defaults to <code>2</code>) &#x2014; Number of consecutive, random and unique samples drawn per label.
This is only relevant for triplet loss and ignored for <code>CosineSimilarityLoss</code>.
Batch size should be a multiple of samples_per_label.`,name:"samples_per_label"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L30"}}),R=new N({props:{name:"apply_hyperparameters",anchor:"setfit.SetFitTrainer.apply_hyperparameters",parameters:[{name:"params",val:": typing.Dict[str, typing.Any]"},{name:"final_model",val:": bool = False"}],parametersDescription:[{anchor:"setfit.SetFitTrainer.apply_hyperparameters.params",description:"<strong>params</strong> (<code>Dict[str, Any]</code>) &#x2014; The parameters, usually from <code>BestRun.hyperparameters</code>",name:"params"},{anchor:"setfit.SetFitTrainer.apply_hyperparameters.final_model",description:"<strong>final_model</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; If <code>True</code>, replace the <code>model_init()</code> function with a fixed model based on the parameters.",name:"final_model"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L196"}}),H=new N({props:{name:"evaluate",anchor:"setfit.SetFitTrainer.evaluate",parameters:[{name:"dataset",val:": typing.Optional[datasets.arrow_dataset.Dataset] = None"}],parametersDescription:[{anchor:"setfit.SetFitTrainer.evaluate.dataset",description:`<strong>dataset</strong> (<code>Dataset</code>, <em>optional</em>) &#x2014;
The dataset to compute the metrics on. If not provided, will use the evaluation dataset passed in the eval_dataset argument at <code>SetFitTrainer</code> initialization.`,name:"dataset"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L418",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The evaluation metrics.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>Dict[str, float]</code></p>
`}}),U=new N({props:{name:"freeze",anchor:"setfit.SetFitTrainer.freeze",parameters:[],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L251"}}),E=new N({props:{name:"hyperparameter_search",anchor:"setfit.SetFitTrainer.hyperparameter_search",parameters:[{name:"hp_space",val:": typing.Union[typing.Callable[[ForwardRef('optuna.Trial')], typing.Dict[str, float]], NoneType] = None"},{name:"compute_objective",val:": typing.Union[typing.Callable[[typing.Dict[str, float]], float], NoneType] = None"},{name:"n_trials",val:": int = 10"},{name:"direction",val:": str = 'maximize'"},{name:"backend",val:": typing.Union[ForwardRef('str'), transformers.trainer_utils.HPSearchBackend, NoneType] = None"},{name:"hp_name",val:": typing.Union[typing.Callable[[ForwardRef('optuna.Trial')], str], NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"setfit.SetFitTrainer.hyperparameter_search.hp_space",description:`<strong>hp_space</strong> (<code>Callable[[&quot;optuna.Trial&quot;], Dict[str, float]]</code>, <em>optional</em>) &#x2014;
A function that defines the hyperparameter search space. Will default to
<code>~trainer_utils.default_hp_space_optuna</code>.`,name:"hp_space"},{anchor:"setfit.SetFitTrainer.hyperparameter_search.compute_objective",description:`<strong>compute_objective</strong> (<code>Callable[[Dict[str, float]], float]</code>, <em>optional</em>) &#x2014;
A function computing the objective to minimize or maximize from the metrics returned by the <code>evaluate</code>
method. Will default to <code>~trainer_utils.default_compute_objective</code> which uses the sum of metrics.`,name:"compute_objective"},{anchor:"setfit.SetFitTrainer.hyperparameter_search.n_trials",description:`<strong>n_trials</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
The number of trial runs to test.`,name:"n_trials"},{anchor:"setfit.SetFitTrainer.hyperparameter_search.direction",description:`<strong>direction</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;maximize&quot;</code>) &#x2014;
Whether to optimize greater or lower objects. Can be <code>&quot;minimize&quot;</code> or <code>&quot;maximize&quot;</code>, you should pick
<code>&quot;minimize&quot;</code> when optimizing the validation loss, <code>&quot;maximize&quot;</code> when optimizing one or several metrics.`,name:"direction"},{anchor:"setfit.SetFitTrainer.hyperparameter_search.backend",description:`<strong>backend</strong> (<code>str</code> or <code>~training_utils.HPSearchBackend</code>, <em>optional</em>) &#x2014;
The backend to use for hyperparameter search. Only optuna is supported for now.
TODO: add support for ray and sigopt.`,name:"backend"},{anchor:"setfit.SetFitTrainer.hyperparameter_search.hp_name",description:`<strong>hp_name</strong> (<code>Callable[[&quot;optuna.Trial&quot;], str]]</code>, <em>optional</em>) &#x2014;
A function that defines the trial/run name. Will default to None.`,name:"hp_name"},{anchor:"setfit.SetFitTrainer.hyperparameter_search.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
Additional keyword arguments passed along to <code>optuna.create_study</code>. For more
information see:</p>
<ul>
<li>the documentation of
<a href="https://optuna.readthedocs.io/en/stable/reference/generated/optuna.study.create_study.html" rel="nofollow">optuna.create_study</a></li>
</ul>`,name:"kwargs"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L458",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>All the information about the best run.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>trainer_utils.BestRun</code></p>
`}}),I=new dt({props:{warning:!0,$$slots:{default:[mt]},$$scope:{ctx:h}}}),j=new N({props:{name:"push_to_hub",anchor:"setfit.SetFitTrainer.push_to_hub",parameters:[{name:"repo_id",val:": str"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"setfit.SetFitTrainer.push_to_hub.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
The full repository ID to push to, e.g. <code>&quot;tomaarsen/setfit_sst2&quot;</code>.`,name:"repo_id"},{anchor:"setfit.SetFitTrainer.push_to_hub.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"setfit.SetFitTrainer.push_to_hub.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Message to commit while pushing.`,name:"commit_message"},{anchor:"setfit.SetFitTrainer.push_to_hub.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the repository created should be private.`,name:"private"},{anchor:"setfit.SetFitTrainer.push_to_hub.api_endpoint",description:`<strong>api_endpoint</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"setfit.SetFitTrainer.push_to_hub.token",description:`<strong>token</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files.
If not set, will use the token set when logging in with
<code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"token"},{anchor:"setfit.SetFitTrainer.push_to_hub.branch",description:`<strong>branch</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to
the default branch as specified in your repository, which
defaults to <code>&quot;main&quot;</code>.`,name:"branch"},{anchor:"setfit.SetFitTrainer.push_to_hub.create_pr",description:`<strong>create_pr</strong> (<code>boolean</code>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <code>branch</code> with that commit.
Defaults to <code>False</code>.`,name:"create_pr"},{anchor:"setfit.SetFitTrainer.push_to_hub.allow_patterns",description:`<strong>allow_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"setfit.SetFitTrainer.push_to_hub.ignore_patterns",description:`<strong>ignore_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L534",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The url of the commit of your model in the given repository.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>str</p>
`}}),V=new N({props:{name:"train",anchor:"setfit.SetFitTrainer.train",parameters:[{name:"num_epochs",val:": typing.Optional[int] = None"},{name:"batch_size",val:": typing.Optional[int] = None"},{name:"learning_rate",val:": typing.Optional[float] = None"},{name:"body_learning_rate",val:": typing.Optional[float] = None"},{name:"l2_weight",val:": typing.Optional[float] = None"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"trial",val:": typing.Union[ForwardRef('optuna.Trial'), typing.Dict[str, typing.Any], NoneType] = None"},{name:"show_progress_bar",val:": bool = True"}],parametersDescription:[{anchor:"setfit.SetFitTrainer.train.num_epochs",description:`<strong>num_epochs</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Temporary change the number of epochs to train the Sentence Transformer body/head for.
If ignore, will use the value given in initialization.`,name:"num_epochs"},{anchor:"setfit.SetFitTrainer.train.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Temporary change the batch size to use for contrastive training or logistic regression.
If ignore, will use the value given in initialization.`,name:"batch_size"},{anchor:"setfit.SetFitTrainer.train.learning_rate",description:`<strong>learning_rate</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Temporary change the learning rate to use for contrastive training or SetFitModel&#x2019;s head in logistic regression.
If ignore, will use the value given in initialization.`,name:"learning_rate"},{anchor:"setfit.SetFitTrainer.train.body_learning_rate",description:`<strong>body_learning_rate</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Temporary change the learning rate to use for SetFitModel&#x2019;s body in logistic regression only.
If ignore, will be the same as <code>learning_rate</code>.`,name:"body_learning_rate"},{anchor:"setfit.SetFitTrainer.train.l2_weight",description:`<strong>l2_weight</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Temporary change the weight of L2 regularization for SetFitModel&#x2019;s differentiable head in logistic regression.`,name:"l2_weight"},{anchor:"setfit.SetFitTrainer.train.max_length",description:`<strong>max_length</strong> (int, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The maximum number of tokens for one data sample. Currently only for training the differentiable head.
If <code>None</code>, will use the maximum number of tokens the model body can accept.
If <code>max_length</code> is greater than the maximum number of acceptable tokens the model body can accept, it will be set to the maximum number of acceptable tokens.`,name:"max_length"},{anchor:"setfit.SetFitTrainer.train.trial",description:`<strong>trial</strong> (<code>optuna.Trial</code> or <code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
The trial run or the hyperparameter dictionary for hyperparameter search.`,name:"trial"},{anchor:"setfit.SetFitTrainer.train.show_progress_bar",description:`<strong>show_progress_bar</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to show a bar that indicates training progress.`,name:"show_progress_bar"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L281"}}),W=new N({props:{name:"unfreeze",anchor:"setfit.SetFitTrainer.unfreeze",parameters:[{name:"keep_body_frozen",val:": bool = False"}],parametersDescription:[{anchor:"setfit.SetFitTrainer.unfreeze.keep_body_frozen",description:`<strong>keep_body_frozen</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to freeze the body when unfreeze the head.`,name:"keep_body_frozen"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer.py#L262"}}),B=new Xe({props:{title:"DistillationSetFitTrainer",local:"setfit.DistillationSetFitTrainer",headingTag:"h1"}}),K=new N({props:{name:"class setfit.DistillationSetFitTrainer",anchor:"setfit.DistillationSetFitTrainer",parameters:[{name:"teacher_model",val:": SetFitModel"},{name:"student_model",val:": typing.Optional[ForwardRef('SetFitModel')] = None"},{name:"train_dataset",val:": typing.Optional[ForwardRef('Dataset')] = None"},{name:"eval_dataset",val:": typing.Optional[ForwardRef('Dataset')] = None"},{name:"model_init",val:": typing.Union[typing.Callable[[], ForwardRef('SetFitModel')], NoneType] = None"},{name:"metric",val:": typing.Union[str, typing.Callable[[ForwardRef('Dataset'), ForwardRef('Dataset')], typing.Dict[str, float]]] = 'accuracy'"},{name:"loss_class",val:": Module = <class 'sentence_transformers.losses.CosineSimilarityLoss.CosineSimilarityLoss'>"},{name:"num_iterations",val:": int = 20"},{name:"num_epochs",val:": int = 1"},{name:"learning_rate",val:": float = 2e-05"},{name:"batch_size",val:": int = 16"},{name:"seed",val:": int = 42"},{name:"column_mapping",val:": typing.Union[typing.Dict[str, str], NoneType] = None"},{name:"use_amp",val:": bool = False"},{name:"warmup_proportion",val:": float = 0.1"}],parametersDescription:[{anchor:"setfit.DistillationSetFitTrainer.teacher_model",description:`<strong>teacher_model</strong> (<code>SetFitModel</code>) &#x2014;
The teacher model to mimic.`,name:"teacher_model"},{anchor:"setfit.DistillationSetFitTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>Dataset</code>) &#x2014;
The training dataset.`,name:"train_dataset"},{anchor:"setfit.DistillationSetFitTrainer.student_model",description:`<strong>student_model</strong> (<code>SetFitModel</code>) &#x2014;
The student model to train. If not provided, a <code>model_init</code> must be passed.`,name:"student_model"},{anchor:"setfit.DistillationSetFitTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>Dataset</code>, <em>optional</em>) &#x2014;
The evaluation dataset.`,name:"eval_dataset"},{anchor:"setfit.DistillationSetFitTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], SetFitModel]</code>, <em>optional</em>) &#x2014;
A function that instantiates the model to be used. If provided, each call to <a href="/docs/setfit/main/en/api/trainer#setfit.DistillationSetFitTrainer.train">train()</a> will start
from a new instance of the model as given by this function when a <code>trial</code> is passed.`,name:"model_init"},{anchor:"setfit.DistillationSetFitTrainer.metric",description:`<strong>metric</strong> (<code>str</code> or <code>Callable</code>, <em>optional</em>, defaults to <code>&quot;accuracy&quot;</code>) &#x2014;
The metric to use for evaluation. If a string is provided, we treat it as the metric name and load it with default settings.
If a callable is provided, it must take two arguments (<code>y_pred</code>, <code>y_test</code>).`,name:"metric"},{anchor:"setfit.DistillationSetFitTrainer.loss_class",description:`<strong>loss_class</strong> (<code>nn.Module</code>, <em>optional</em>, defaults to <code>CosineSimilarityLoss</code>) &#x2014;
The loss function to use for contrastive training.`,name:"loss_class"},{anchor:"setfit.DistillationSetFitTrainer.num_iterations",description:`<strong>num_iterations</strong> (<code>int</code>, <em>optional</em>, defaults to <code>20</code>) &#x2014;
The number of iterations to generate sentence pairs for.`,name:"num_iterations"},{anchor:"setfit.DistillationSetFitTrainer.num_epochs",description:`<strong>num_epochs</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
The number of epochs to train the Sentence Transformer body for.`,name:"num_epochs"},{anchor:"setfit.DistillationSetFitTrainer.learning_rate",description:`<strong>learning_rate</strong> (<code>float</code>, <em>optional</em>, defaults to <code>2e-5</code>) &#x2014;
The learning rate to use for contrastive training.`,name:"learning_rate"},{anchor:"setfit.DistillationSetFitTrainer.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>16</code>) &#x2014;
The batch size to use for contrastive training.`,name:"batch_size"},{anchor:"setfit.DistillationSetFitTrainer.seed",description:`<strong>seed</strong> (<code>int</code>, <em>optional</em>, defaults to 42) &#x2014;
Random seed that will be set at the beginning of training. To ensure reproducibility across runs, use the
<code>~SetTrainer.model_init</code> function to instantiate the model if it has some randomly initialized parameters.`,name:"seed"},{anchor:"setfit.DistillationSetFitTrainer.column_mapping",description:`<strong>column_mapping</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A mapping from the column names in the dataset to the column names expected by the model. The expected format is a dictionary with the following format: {&#x201C;text_column_name&#x201D;: &#x201C;text&#x201D;, &#x201C;label_column_name: &#x201C;label&#x201D;}.`,name:"column_mapping"},{anchor:"setfit.DistillationSetFitTrainer.use_amp",description:`<strong>use_amp</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Use Automatic Mixed Precision (AMP). Only for Pytorch &gt;= 1.6.0`,name:"use_amp"},{anchor:"setfit.DistillationSetFitTrainer.warmup_proportion",description:`<strong>warmup_proportion</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.1</code>) &#x2014;
Proportion of the warmup in the total training steps.
Must be greater than or equal to 0.0 and less than or equal to 1.0.`,name:"warmup_proportion"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer_distillation.py#L26"}}),G=new N({props:{name:"train",anchor:"setfit.DistillationSetFitTrainer.train",parameters:[{name:"num_epochs",val:": typing.Optional[int] = None"},{name:"batch_size",val:": typing.Optional[int] = None"},{name:"learning_rate",val:": typing.Optional[float] = None"},{name:"body_learning_rate",val:": typing.Optional[float] = None"},{name:"l2_weight",val:": typing.Optional[float] = None"},{name:"trial",val:": typing.Union[ForwardRef('optuna.Trial'), typing.Dict[str, typing.Any], NoneType] = None"},{name:"show_progress_bar",val:": bool = True"}],parametersDescription:[{anchor:"setfit.DistillationSetFitTrainer.train.num_epochs",description:`<strong>num_epochs</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Temporary change the number of epochs to train the Sentence Transformer body/head for.
If ignore, will use the value given in initialization.`,name:"num_epochs"},{anchor:"setfit.DistillationSetFitTrainer.train.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Temporary change the batch size to use for contrastive training or logistic regression.
If ignore, will use the value given in initialization.`,name:"batch_size"},{anchor:"setfit.DistillationSetFitTrainer.train.learning_rate",description:`<strong>learning_rate</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Temporary change the learning rate to use for contrastive training or SetFitModel&#x2019;s head in logistic regression.
If ignore, will use the value given in initialization.`,name:"learning_rate"},{anchor:"setfit.DistillationSetFitTrainer.train.body_learning_rate",description:`<strong>body_learning_rate</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Temporary change the learning rate to use for SetFitModel&#x2019;s body in logistic regression only.
If ignore, will be the same as <code>learning_rate</code>.`,name:"body_learning_rate"},{anchor:"setfit.DistillationSetFitTrainer.train.l2_weight",description:`<strong>l2_weight</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Temporary change the weight of L2 regularization for SetFitModel&#x2019;s differentiable head in logistic regression.`,name:"l2_weight"},{anchor:"setfit.DistillationSetFitTrainer.train.trial",description:`<strong>trial</strong> (<code>optuna.Trial</code> or <code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
The trial run or the hyperparameter dictionary for hyperparameter search.`,name:"trial"},{anchor:"setfit.DistillationSetFitTrainer.train.show_progress_bar",description:`<strong>show_progress_bar</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to show a bar that indicates training progress.`,name:"show_progress_bar"}],source:"https://github.com/huggingface/setfit/blob/main/src/setfit/trainer_distillation.py#L104"}}),{c(){n=l("meta"),g=r(),f=l("p"),d=r(),y(a.$$.fragment),u=r(),o=l("div"),y(O.$$.fragment),ve=r(),J=l("p"),J.textContent=He,Te=r(),k=l("div"),y(R.$$.fragment),xe=r(),Q=l("p"),Q.textContent=Ue,we=r(),M=l("div"),y(H.$$.fragment),Fe=r(),X=l("p"),X.textContent=Ee,Se=r(),L=l("div"),y(U.$$.fragment),$e=r(),Y=l("p"),Y.textContent=je,De=r(),C=l("div"),y(E.$$.fragment),Ce=r(),Z=l("p"),Z.innerHTML=Ve,ze=r(),y(I.$$.fragment),Ne=r(),z=l("div"),y(j.$$.fragment),ke=r(),ee=l("p"),ee.innerHTML=We,Me=r(),te=l("p"),te.innerHTML=Be,Le=r(),q=l("div"),y(V.$$.fragment),Ie=r(),ne=l("p"),ne.textContent=Ke,qe=r(),P=l("div"),y(W.$$.fragment),Pe=r(),oe=l("p"),oe.textContent=Ge,de=r(),y(B.$$.fragment),me=r(),D=l("div"),y(K.$$.fragment),Ae=r(),ae=l("p"),ae.textContent=Je,Oe=r(),A=l("div"),y(G.$$.fragment),Re=r(),ie=l("p"),ie.textContent=Qe,pe=r(),ce=l("p"),this.h()},l(e){const p=st("svelte-u9bgzb",document.head);n=c(p,"META",{name:!0,content:!0}),p.forEach(i),g=s(e),f=c(e,"P",{}),w(f).forEach(i),d=s(e),v(a.$$.fragment,e),u=s(e),o=c(e,"DIV",{class:!0});var m=w(o);v(O.$$.fragment,m),ve=s(m),J=c(m,"P",{"data-svelte-h":!0}),S(J)!=="svelte-gptbkh"&&(J.textContent=He),Te=s(m),k=c(m,"DIV",{class:!0});var ge=w(k);v(R.$$.fragment,ge),xe=s(ge),Q=c(ge,"P",{"data-svelte-h":!0}),S(Q)!=="svelte-1gb5peh"&&(Q.textContent=Ue),ge.forEach(i),we=s(m),M=c(m,"DIV",{class:!0});var fe=w(M);v(H.$$.fragment,fe),Fe=s(fe),X=c(fe,"P",{"data-svelte-h":!0}),S(X)!=="svelte-bomxx4"&&(X.textContent=Ee),fe.forEach(i),Se=s(m),L=c(m,"DIV",{class:!0});var ue=w(L);v(U.$$.fragment,ue),$e=s(ue),Y=c(ue,"P",{"data-svelte-h":!0}),S(Y)!=="svelte-wpqzbi"&&(Y.textContent=je),ue.forEach(i),De=s(m),C=c(m,"DIV",{class:!0});var re=w(C);v(E.$$.fragment,re),Ce=s(re),Z=c(re,"P",{"data-svelte-h":!0}),S(Z)!=="svelte-1swdj1s"&&(Z.innerHTML=Ve),ze=s(re),v(I.$$.fragment,re),re.forEach(i),Ne=s(m),z=c(m,"DIV",{class:!0});var se=w(z);v(j.$$.fragment,se),ke=s(se),ee=c(se,"P",{"data-svelte-h":!0}),S(ee)!=="svelte-f2unia"&&(ee.innerHTML=We),Me=s(se),te=c(se,"P",{"data-svelte-h":!0}),S(te)!=="svelte-1mz0ik2"&&(te.innerHTML=Be),se.forEach(i),Le=s(m),q=c(m,"DIV",{class:!0});var _e=w(q);v(V.$$.fragment,_e),Ie=s(_e),ne=c(_e,"P",{"data-svelte-h":!0}),S(ne)!=="svelte-1cilnet"&&(ne.textContent=Ke),_e.forEach(i),qe=s(m),P=c(m,"DIV",{class:!0});var be=w(P);v(W.$$.fragment,be),Pe=s(be),oe=c(be,"P",{"data-svelte-h":!0}),S(oe)!=="svelte-1p0xvp3"&&(oe.textContent=Ge),be.forEach(i),m.forEach(i),de=s(e),v(B.$$.fragment,e),me=s(e),D=c(e,"DIV",{class:!0});var le=w(D);v(K.$$.fragment,le),Ae=s(le),ae=c(le,"P",{"data-svelte-h":!0}),S(ae)!=="svelte-hai2sx"&&(ae.textContent=Je),Oe=s(le),A=c(le,"DIV",{class:!0});var ye=w(A);v(G.$$.fragment,ye),Re=s(ye),ie=c(ye,"P",{"data-svelte-h":!0}),S(ie)!=="svelte-1cilnet"&&(ie.textContent=Qe),ye.forEach(i),le.forEach(i),pe=s(e),ce=c(e,"P",{}),w(ce).forEach(i),this.h()},h(){F(n,"name","hf:doc:metadata"),F(n,"content",ht),F(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,p){t(document.head,n),$(e,g,p),$(e,f,p),$(e,d,p),T(a,e,p),$(e,u,p),$(e,o,p),T(O,o,null),t(o,ve),t(o,J),t(o,Te),t(o,k),T(R,k,null),t(k,xe),t(k,Q),t(o,we),t(o,M),T(H,M,null),t(M,Fe),t(M,X),t(o,Se),t(o,L),T(U,L,null),t(L,$e),t(L,Y),t(o,De),t(o,C),T(E,C,null),t(C,Ce),t(C,Z),t(C,ze),T(I,C,null),t(o,Ne),t(o,z),T(j,z,null),t(z,ke),t(z,ee),t(z,Me),t(z,te),t(o,Le),t(o,q),T(V,q,null),t(q,Ie),t(q,ne),t(o,qe),t(o,P),T(W,P,null),t(P,Pe),t(P,oe),$(e,de,p),T(B,e,p),$(e,me,p),$(e,D,p),T(K,D,null),t(D,Ae),t(D,ae),t(D,Oe),t(D,A),T(G,A,null),t(A,Re),t(A,ie),$(e,pe,p),$(e,ce,p),he=!0},p(e,[p]){const m={};p&2&&(m.$$scope={dirty:p,ctx:e}),I.$set(m)},i(e){he||(_(a.$$.fragment,e),_(O.$$.fragment,e),_(R.$$.fragment,e),_(H.$$.fragment,e),_(U.$$.fragment,e),_(E.$$.fragment,e),_(I.$$.fragment,e),_(j.$$.fragment,e),_(V.$$.fragment,e),_(W.$$.fragment,e),_(B.$$.fragment,e),_(K.$$.fragment,e),_(G.$$.fragment,e),he=!0)},o(e){b(a.$$.fragment,e),b(O.$$.fragment,e),b(R.$$.fragment,e),b(H.$$.fragment,e),b(U.$$.fragment,e),b(E.$$.fragment,e),b(I.$$.fragment,e),b(j.$$.fragment,e),b(V.$$.fragment,e),b(W.$$.fragment,e),b(B.$$.fragment,e),b(K.$$.fragment,e),b(G.$$.fragment,e),he=!1},d(e){e&&(i(g),i(f),i(d),i(u),i(o),i(de),i(me),i(D),i(pe),i(ce)),i(n),x(a,e),x(O),x(R),x(H),x(U),x(E),x(I),x(j),x(V),x(W),x(B,e),x(K),x(G)}}}const ht='{"title":"SetFitTrainer","local":"setfit.SetFitTrainer","sections":[],"depth":1}';function gt(h){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class yt extends Ze{constructor(n){super(),et(this,n,gt,pt,Ye,{})}}export{yt as component};
